#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "vajTestObjects.h"
#include "vajTestTraps.h"

#include <unistd.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>
#include "app.h"

/*
 *  ͭ³
 */
void *init_mibval()
{
    key_t   our_key;
    int     our_id;
    void   *mibval_ptr;

    if((our_key = ftok(KEYPATH, KEYID)) == -1){
        fprintf(stderr, "Failed to initializing SHARED-MEMORY."
                        " ftok() errno=%d [%s]\n", errno, strerror(errno));
        exit(1);
    }
    if((our_id = shmget(our_key, sizeof(mibval), 0)) == -1){
        fprintf(stderr, "Failed to initializing SHARED-MEMORY."
                        " shmget() errno=%d [%s]\n", errno, strerror(errno));
        exit(1);
    }
    if((mibval_ptr = shmat(our_id, NULL, 0)) == (void *)-1){
        fprintf(stderr, "Failed to initializing SHARED-MEMORY."
                        " shmat() errno=%d [%s]\n", errno, strerror(errno));
        exit(1);
    }

    return(mibval_ptr);
}
void rel_mibval(void *mibval_ptr)
{
    shmdt(mibval_ptr);
}


/*
 *  SNMP٥Ƚλ
 */
static int  keep_running = 1;
RETSIGTYPE byebye(int a)
{
    keep_running = 0;
}


/*
 *  ᥤ
 */
int main(int argc, char *argv[])
{
    void   *mibval_ptr;
    int     arg;
    char    options[] = "D:d";
    int     go_daemon = 0;

    // ͭ³
    mibval_ptr = init_mibval();

    // ưѥ᡼
    while((arg = getopt(argc, argv, options)) != -1){
        switch(arg){
        case 'D':   debug_register_tokens(optarg);
                    snmp_set_do_debugging(1);
                    break;
        case 'd':   go_daemon = 1;
                    break;
        default:    fprintf(stderr, "Usage: [-D\"vajTestObjects,...\"] [-d]\n"
                                    "   D --- output the debugging statement\n"
                                    "   d --- going a daemon mode.\n");
                    exit(9);
        }
    }
    if(go_daemon){
        snmp_enable_syslog();           // syslog:LOG_DAEMON
        snmp_log_syslogname("vajTest");
        netsnmp_daemonize(1, 0);        // ǡ
    }else{
        snmp_enable_stderrlog();        // STDERR
    }

    // ȡ饤
    netsnmp_ds_set_boolean(NETSNMP_DS_APPLICATION_ID, NETSNMP_DS_AGENT_ROLE, 1);

    init_agent("vajTest");              // Ƚ + vajTest.confϿ

    init_vajTestObjects(mibval_ptr);    // ⥸塼

    init_snmp("vajTest");               // 饤֥ + vajTest.confɽ

    // SNMP٥ȽλϢŤ
    signal(SIGTERM, byebye);
    signal(SIGINT, byebye);

    // SNMPȥå׽
    snmp_log(LOG_INFO, "Starting vajTest." );
    send_vajTestStart_trap();

    // SNMP٥Ƚ
    while(keep_running) {
        agent_check_and_process(1);
    }

    // SNMPȥå׽
    snmp_log(LOG_INFO, "Stopping vajTest." );
    send_vajTestStop_trap();

    snmp_shutdown("vajTest");           // Ƚλ

    // ͭ
    rel_mibval(mibval_ptr);

    exit(0);
}
